Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2696)
@@ -1246,39 +2297,169 @@
 !--    Calculate sky transmissivity
        sky_trans = 0.6_wp + 0.2_wp * zenith(0)
-
-!
-!--    Calculate value of the Exner function
+!
+!--    Calculate value of the Exner function at model surface
        exn = (surface_pressure / 1000.0_wp )**0.286_wp
 !
-!--    Calculate radiation fluxes and net radiation (rad_net) for each grid 
-!--    point
-       DO i = nxlg, nxrg
-          DO j = nysg, nyng
-!
-!--          Obtain vertical index of topography top 
-             k = get_topography_top_index( j, i, 's' )
-
-             exn1 = (hyp(k+1) / 100000.0_wp )**0.286_wp
-
-             rad_sw_in(0,j,i)  = solar_constant * sky_trans * zenith(0)
-             rad_sw_out(0,j,i) = alpha(j,i) * rad_sw_in(0,j,i)
-             rad_lw_out(0,j,i) = emis(j,i) * sigma_sb * (pt(k,j,i) * exn)**4
-
-             IF ( cloud_physics  .OR.  cloud_droplets )  THEN
-                pt1 = pt(k+1,j,i) + l_d_cp / exn1 * ql(k+1,j,i)
-                rad_lw_in(0,j,i)  = 0.8_wp * sigma_sb * (pt1 * exn1)**4
+!--    In case averaged radiation is used, calculate mean temperature and 
+!--    liquid water mixing ratio at the urban-layer top.
+       IF ( average_radiation ) THEN   
+          pt1   = 0.0_wp
+          IF ( cloud_physics )  ql1   = 0.0_wp
+
+          pt1_l = SUM( pt(nzut,nys:nyn,nxl:nxr) )
+          IF ( cloud_physics )  ql1_l = SUM( ql(nzut,nys:nyn,nxl:nxr) )
+
+#if defined( __parallel )      
+          IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
+          CALL MPI_ALLREDUCE( pt1_l, pt1, 1, MPI_REAL, MPI_SUM, comm2d, ierr )
+          IF ( cloud_physics )                                                 &
+             CALL MPI_ALLREDUCE( ql1_l, ql1, 1, MPI_REAL, MPI_SUM, comm2d, ierr )
+#else
+          pt1 = pt1_l 
+          IF ( cloud_physics )  ql1 = ql1_l
+#endif
+          IF ( cloud_physics )  pt1 = pt1 + l_d_cp / exn1 * ql1
+!
+!--       Finally, divide by number of grid points
+          pt1 = pt1 / REAL( ( nx + 1 ) * ( ny + 1 ), KIND=wp )
+       ENDIF
+!
+!--    Call clear-sky calculation for each surface orientation. 
+!--    First, horizontal surfaces
+       surf => surf_def_h(0)
+       CALL radiation_clearsky_surf
+       surf => surf_lsm_h
+       CALL radiation_clearsky_surf
+       surf => surf_usm_h
+       CALL radiation_clearsky_surf
+!
+!--    Vertical surfaces
+       DO  l = 0, 3
+          surf => surf_def_v(l)
+          CALL radiation_clearsky_surf
+          surf => surf_lsm_v(l)
+          CALL radiation_clearsky_surf
+          surf => surf_usm_v(l)
+          CALL radiation_clearsky_surf
+       ENDDO
+
+       CONTAINS
+
+          SUBROUTINE radiation_clearsky_surf
+
+             IMPLICIT NONE
+
+             INTEGER(iwp) ::  i         !< index x-direction
+             INTEGER(iwp) ::  ioff      !< offset between surface element and adjacent grid point along x
+             INTEGER(iwp) ::  j         !< index y-direction
+             INTEGER(iwp) ::  joff      !< offset between surface element and adjacent grid point along y
+             INTEGER(iwp) ::  k         !< index z-direction
+             INTEGER(iwp) ::  koff      !< offset between surface element and adjacent grid point along z
+             INTEGER(iwp) ::  m         !< running index for surface elements
+
+             IF ( surf%ns < 1 )  RETURN
+
+!
+!--          Calculate radiation fluxes and net radiation (rad_net) assuming 
+!--          homogeneous urban radiation conditions. 
+             IF ( average_radiation ) THEN       
+
+                k = nzut
+!
+!-- MS: Why k+1 ? 
+!-- MS: @Mohamed: emissivity belongs now to surface type with 3 different values for each 
+!--               surface element (due to tile approach).
+                exn1 = ( hyp(k+1) / 100000.0_wp )**0.286_wp
+
+                surf%rad_sw_in  = solar_constant * sky_trans * zenith(0)
+                surf%rad_sw_out = albedo_urb * surf%rad_sw_in
+                
+                surf%rad_lw_in  = 0.8_wp * sigma_sb * (pt1 * exn1)**4
+
+                surf%rad_lw_out = emissivity_urb * sigma_sb * (t_rad_urb)**4   &
+                                    + (1.0_wp - emissivity_urb) * surf%rad_lw_in
+
+                surf%rad_net = surf%rad_sw_in - surf%rad_sw_out                &
+                             + surf%rad_lw_in - surf%rad_lw_out
+
+                surf%rad_lw_out_change_0 = 3.0_wp * emissivity_urb * sigma_sb  &
+                                           * (t_rad_urb)**3
+
+!
+!--          Calculate radiation fluxes and net radiation (rad_net) for each surface 
+!--          element.
              ELSE
-                rad_lw_in(0,j,i)  = 0.8_wp * sigma_sb * (pt(k+1,j,i) * exn1)**4
+!
+!--             Determine index offset between surface element and adjacent 
+!--             atmospheric grid point (depends on surface orientation). 
+                ioff = surf%ioff
+                joff = surf%joff
+                koff = surf%koff
+
+                DO  m = 1, surf%ns
+                   i = surf%i(m)
+                   j = surf%j(m)
+                   k = surf%k(m)
+
+                   exn1 = (hyp(k) / 100000.0_wp )**0.286_wp
+
+                   surf%rad_sw_in(m)  = solar_constant * sky_trans * zenith(0)
+!
+!--                Weighted average according to surface fraction. 
+!--                In case no surface fraction is given ( default-type )
+!--                no weighted averaging is performed ( only one surface type per
+!--                surface element ). 
+                   IF ( ALLOCATED( surf%frac ) )  THEN
+
+                      surf%rad_sw_out(m) = ( surf%frac(0,m) * surf%albedo(0,m)    &
+                                           + surf%frac(1,m) * surf%albedo(1,m)    &
+                                           + surf%frac(2,m) * surf%albedo(2,m) )  &
+                                           * surf%rad_sw_in(m)
+
+                      surf%rad_lw_out(m) = ( surf%frac(0,m) * surf%emissivity(0,m)&
+                                           + surf%frac(1,m) * surf%emissivity(1,m)&
+                                           + surf%frac(2,m) * surf%emissivity(2,m)&
+                                           )                                      &
+                                           * sigma_sb                             &
+                                           * ( pt(k+koff,j+joff,i+ioff) * exn )**4
+
+
+                      surf%rad_lw_out_change_0(m) =                               &
+                                         ( surf%frac(0,m) * surf%emissivity(0,m)  &
+                                         + surf%frac(1,m) * surf%emissivity(1,m)  &
+                                         + surf%frac(2,m) * surf%emissivity(2,m)  &
+                                         ) * 3.0_wp * sigma_sb                    &
+                                         * ( pt(k+koff,j+joff,i+ioff) * exn )** 3
+
+                   ELSE
+
+                      surf%rad_sw_out(m) = surf%albedo(0,m) * surf%rad_sw_in(m)
+
+                      surf%rad_lw_out(m) = surf%emissivity(0,m)                   &
+                                           * sigma_sb                             &
+                                           * ( pt(k+koff,j+joff,i+ioff) * exn )**4
+
+
+                      surf%rad_lw_out_change_0(m) = surf%emissivity(0,m)          &
+                                           * 3.0_wp * sigma_sb                    &
+                                           * ( pt(k+koff,j+joff,i+ioff) * exn )** 3
+
+                   ENDIF
+
+                   IF ( cloud_physics )  THEN
+                      pt1 = pt(k,j,i) + l_d_cp / exn1 * ql(k,j,i)
+                      surf%rad_lw_in(m)  = 0.8_wp * sigma_sb * (pt1 * exn1)**4
+                   ELSE
+                      surf%rad_lw_in(m)  = 0.8_wp * sigma_sb * (pt(k,j,i) * exn1)**4
+                   ENDIF
+
+                   surf%rad_net(m) = surf%rad_sw_in(m) - surf%rad_sw_out(m)       &
+                                   + surf%rad_lw_in(m) - surf%rad_lw_out(m)
+
+                ENDDO
+
              ENDIF
 
-             rad_net(j,i) = rad_sw_in(0,j,i) - rad_sw_out(0,j,i)               &
-                            + rad_lw_in(0,j,i) - rad_lw_out(0,j,i)
-
-
-             rad_lw_out_change_0(j,i) = 3.0_wp * sigma_sb * emis(j,i)         &
-                                        * (pt(k,j,i) * exn) ** 3
-
-          ENDDO
-       ENDDO
+          END SUBROUTINE radiation_clearsky_surf
 
     END SUBROUTINE radiation_clearsky
@@ -1295,8 +2476,14 @@
        IMPLICIT NONE
 
-       INTEGER(iwp) :: i, j, k   !< loop indices
-       REAL(wp)     :: exn,   &  !< Exner functions at surface
-                       exn1,  &  !< Exner functions at first grid level
-                       pt1       !< potential temperature at first grid level
+       INTEGER(iwp) ::  l         !< running index for surface orientation
+
+       REAL(wp)     ::  exn       !< Exner functions at surface
+       REAL(wp)     ::  exn1      !< Exner functions at first grid level
+       REAL(wp)     ::  pt1       !< potential temperature at first grid level or mean value at urban layer top 
+       REAL(wp)     ::  pt1_l     !< potential temperature at first grid level or mean value at urban layer top at local subdomain 
+       REAL(wp)     ::  ql1       !< liquid water mixing ratio at first grid level or mean value at urban layer top 
+       REAL(wp)     ::  ql1_l     !< liquid water mixing ratio at first grid level or mean value at urban layer top at local subdomain 
+
+       TYPE(surf_type), POINTER ::  surf !< pointer on respective surface type, used to generalize routine   
 
 !
@@ -1304,33 +2491,165 @@
        exn = (surface_pressure / 1000.0_wp )**0.286_wp
 !
-!--    Prescribe net radiation and estimate the remaining radiative fluxes
-       DO i = nxlg, nxrg
-          DO j = nysg, nyng
-!
-!--          Obtain vertical index of topography top. So far it is identical to
-!--          nzb.
-             k = get_topography_top_index( j, i, 's' )
-
-             rad_net(j,i)      = net_radiation
-
-             exn1 = (hyp(k+1) / 100000.0_wp )**0.286_wp
-
-             IF ( cloud_physics  .OR.  cloud_droplets )  THEN
-                pt1 = pt(k+1,j,i) + l_d_cp / exn1 * ql(k+1,j,i)
-                rad_lw_in(0,j,i)  = 0.8_wp * sigma_sb * (pt1 * exn1)**4
+!--    In case averaged radiation is used, calculate mean temperature and 
+!--    liquid water mixing ratio at the urban-layer top.
+       IF ( average_radiation ) THEN   
+          pt1   = 0.0_wp
+          IF ( cloud_physics )  ql1   = 0.0_wp
+
+          pt1_l = SUM( pt(nzut,nys:nyn,nxl:nxr) )
+          IF ( cloud_physics )  ql1_l = SUM( ql(nzut,nys:nyn,nxl:nxr) )
+
+#if defined( __parallel )      
+          IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
+          CALL MPI_ALLREDUCE( pt1_l, pt1, 1, MPI_REAL, MPI_SUM, comm2d, ierr )
+          IF ( cloud_physics )                                                 &
+             CALL MPI_ALLREDUCE( ql1_l, ql1, 1, MPI_REAL, MPI_SUM, comm2d, ierr )
+#else
+          pt1 = pt1_l
+          IF ( cloud_physics )  ql1 = ql1_l
+#endif
+          IF ( cloud_physics )  pt1 = pt1 + l_d_cp / exn1 * ql1
+!
+!--       Finally, divide by number of grid points
+          pt1 = pt1 / REAL( ( nx + 1 ) * ( ny + 1 ), KIND=wp )
+       ENDIF
+
+!
+!--    First, horizontal surfaces
+       surf => surf_def_h(0)
+       CALL radiation_constant_surf
+       surf => surf_lsm_h
+       CALL radiation_constant_surf
+       surf => surf_usm_h
+       CALL radiation_constant_surf
+!
+!--    Vertical surfaces
+       DO  l = 0, 3
+          surf => surf_def_v(l)
+          CALL radiation_constant_surf
+          surf => surf_lsm_v(l)
+          CALL radiation_constant_surf
+          surf => surf_usm_v(l)
+          CALL radiation_constant_surf
+       ENDDO
+
+       CONTAINS
+
+          SUBROUTINE radiation_constant_surf
+
+             IMPLICIT NONE
+
+             INTEGER(iwp) ::  i         !< index x-direction
+             INTEGER(iwp) ::  ioff      !< offset between surface element and adjacent grid point along x
+             INTEGER(iwp) ::  j         !< index y-direction
+             INTEGER(iwp) ::  joff      !< offset between surface element and adjacent grid point along y
+             INTEGER(iwp) ::  k         !< index z-direction
+             INTEGER(iwp) ::  koff      !< offset between surface element and adjacent grid point along z
+             INTEGER(iwp) ::  m         !< running index for surface elements
+
+             IF ( surf%ns < 1 )  RETURN
+
+!--          Calculate homogenoeus urban radiation fluxes
+             IF ( average_radiation ) THEN
+
+                ! set height above canopy
+                k = nzut
+
+                surf%rad_net = net_radiation
+! MS: Wyh k + 1 ?
+                exn1 = (hyp(k+1) / 100000.0_wp )**0.286_wp
+
+                surf%rad_lw_in  = 0.8_wp * sigma_sb * (pt1 * exn1)**4
+
+                surf%rad_lw_out = emissivity_urb * sigma_sb * (t_rad_urb)**4   &
+                                    + ( 10.0_wp - emissivity_urb )             & ! shouldn't be this a bulk value -- emissivity_urb?
+                                    * surf%rad_lw_in
+
+                surf%rad_lw_out_change_0 = 3.0_wp * emissivity_urb * sigma_sb  &
+                                           * t_rad_urb**3
+
+                surf%rad_sw_in = ( surf%rad_net - surf%rad_lw_in               &
+                                     + surf%rad_lw_out )                       &
+                                     / ( 1.0_wp - albedo_urb )
+
+                surf%rad_sw_out =  albedo_urb * surf%rad_sw_in
+
+!
+!--          Calculate radiation fluxes for each surface element
              ELSE
-                rad_lw_in(0,j,i)  = 0.8_wp * sigma_sb * (pt(k+1,j,i) * exn1)**4
+!
+!--             Determine index offset between surface element and adjacent 
+!--             atmospheric grid point
+                ioff = surf%ioff
+                joff = surf%joff
+                koff = surf%koff
+
+!
+!--             Prescribe net radiation and estimate the remaining radiative fluxes
+                DO  m = 1, surf%ns
+                   i = surf%i(m)
+                   j = surf%j(m)
+                   k = surf%k(m)
+
+                   surf%rad_net(m) = net_radiation
+
+                   exn1 = (hyp(k) / 100000.0_wp )**0.286_wp
+
+                   IF ( cloud_physics )  THEN
+                      pt1 = pt(k,j,i) + l_d_cp / exn1 * ql(k,j,i)
+                      surf%rad_lw_in(m)  = 0.8_wp * sigma_sb * (pt1 * exn1)**4
+                   ELSE
+                      surf%rad_lw_in(m)  = 0.8_wp * sigma_sb *                    &
+                                             ( pt(k,j,i) * exn1 )**4
+                   ENDIF
+
+!
+!--                Weighted average according to surface fraction. 
+!--                In case no surface fraction is given ( default-type )
+!--                no weighted averaging is performed ( only one surface type per
+!--                surface element ). 
+                   IF ( ALLOCATED( surf%frac ) )  THEN
+
+                      surf%rad_lw_out(m) = ( surf%frac(0,m) * surf%emissivity(0,m)&
+                                           + surf%frac(1,m) * surf%emissivity(1,m)&
+                                           + surf%frac(2,m) * surf%emissivity(2,m)&
+                                           )                                      &
+                                         * sigma_sb                               &
+                                         * ( pt(k+koff,j+joff,i+ioff) * exn )**4
+
+                      surf%rad_sw_in(m) = ( surf%rad_net(m) - surf%rad_lw_in(m)   &
+                                          + surf%rad_lw_out(m) )                  &
+                                          / ( 1.0_wp -                            &
+                                             ( surf%frac(0,m) * surf%albedo(0,m) +&
+                                               surf%frac(1,m) * surf%albedo(1,m) +&
+                                               surf%frac(1,m) * surf%albedo(1,m) )&
+                                            )
+
+                      surf%rad_sw_out(m) = ( surf%frac(0,m) * surf%albedo(0,m)    &
+                                           + surf%frac(1,m) * surf%albedo(1,m)    &
+                                           + surf%frac(2,m) * surf%albedo(2,m) )  &
+                                         * surf%rad_sw_in(m)
+
+                   ELSE
+                      surf%rad_lw_out(m) = surf%emissivity(0,m)                   &
+                                         * sigma_sb                               &
+                                         * ( pt(k+koff,j+joff,i+ioff) * exn )**4
+
+                      surf%rad_sw_in(m) = ( surf%rad_net(m) - surf%rad_lw_in(m)   &
+                                          + surf%rad_lw_out(m) )                  &
+                                          / ( 1.0_wp -                            &
+                                             ( surf%frac(0,m) * surf%albedo(0,m) )&
+                                            )
+
+                      surf%rad_sw_out(m) = ( surf%frac(0,m) * surf%albedo(0,m) )  &
+                                         * surf%rad_sw_in(m)
+                   ENDIF
+
+                ENDDO
+
              ENDIF
 
-             rad_lw_out(0,j,i) = emis(j,i) * sigma_sb * (pt(k,j,i) * exn)**4
-
-             rad_sw_in(0,j,i) = ( rad_net(j,i) - rad_lw_in(0,j,i)              &
-                                  + rad_lw_out(0,j,i) )                        &
-                                  / ( 1.0_wp - alpha(j,i) )
-
-             rad_sw_out(0,j,i) =  alpha(j,i) * rad_sw_in(0,j,i)
-
-          ENDDO
-       ENDDO
+          END SUBROUTINE radiation_constant_surf
+          
 
     END SUBROUTINE radiation_constant
@@ -1364,8 +2683,14 @@
        ENDIF 
 
-       IF ( albedo_type == 0 )  THEN
-          WRITE( io, 7 ) albedo
-       ELSE
-          WRITE( io, 8 ) TRIM( albedo_type_name(albedo_type) )
+       IF ( albedo_type_f%from_file  .OR.  vegetation_type_f%from_file  .OR.   &
+            pavement_type_f%from_file  .OR.  water_type_f%from_file  .OR.      &
+            building_type_f%from_file )  THEN
+             WRITE( io, 13 )
+       ELSE  
+          IF ( albedo_type == 0 )  THEN
+             WRITE( io, 7 ) albedo
+          ELSE
+             WRITE( io, 8 ) TRIM( albedo_type_name(albedo_type) )
+          ENDIF
        ENDIF
        IF ( constant_albedo )  THEN
@@ -1389,4 +2714,6 @@
 11 FORMAT (/'    --> Shortwave radiation is disabled.')
 12 FORMAT  ('    Timestep: dt_radiation = ', F6.2, '  s')
+13 FORMAT (/'    Albedo is set individually for each xy-location, according '  &
+                 'to given surface type.')
 
 
@@ -1411,5 +2738,16 @@
                                   lw_radiation, net_radiation,                 &
                                   radiation_scheme, skip_time_do_radiation,    &
-                                  sw_radiation, unscheduled_radiation_calls
+                                  sw_radiation, unscheduled_radiation_calls,   &
+                                  split_diffusion_radiation,                   &
+                                  energy_balance_surf_h,                       &
+                                  energy_balance_surf_v,                       &
+                                  read_svf_on_init,                            &
+                                  nrefsteps,                                   &
+                                  write_svf_on_init,                           &
+                                  mrt_factors,                                 &
+                                  dist_max_svf,                                &
+                                  average_radiation,                           &
+                                  radiation_interactions, atm_surfaces,        &
+                                  surf_reflections
        
        line = ' '
@@ -1456,5 +2794,6 @@
 #if defined ( __rrtmg )
 
-       INTEGER(iwp) :: i, j, k, n !< loop indices
+       INTEGER(iwp) ::  i, j, k, l, m, n !< loop indices
+       INTEGER(iwp) ::  k_topo     !< topography top index
 
        REAL(wp)     ::  nc_rad, &    !< number concentration of cloud droplets
@@ -1462,11 +2801,37 @@
                         s_r3         !< weighted sum over all droplets with r^3
 
+       REAL(wp), DIMENSION(0:nzt+1) :: pt_av, q_av, ql_av
+!
+!--    Just dummy arguments
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: rrtm_lw_taucld_dum,          &
+                                                  rrtm_lw_tauaer_dum,          &
+                                                  rrtm_sw_taucld_dum,          &
+                                                  rrtm_sw_ssacld_dum,          &
+                                                  rrtm_sw_asmcld_dum,          &
+                                                  rrtm_sw_fsfcld_dum,          &
+                                                  rrtm_sw_tauaer_dum,          &
+                                                  rrtm_sw_ssaaer_dum,          &
+                                                  rrtm_sw_asmaer_dum,          &
+                                                  rrtm_sw_ecaer_dum
+
 !
 !--    Calculate current (cosine of) zenith angle and whether the sun is up
        CALL calc_zenith     
 !
-!--    Calculate surface albedo
+!--    Calculate surface albedo. In case average radiation is applied, 
+!--    this is not required.
        IF ( .NOT. constant_albedo )  THEN
-          CALL calc_albedo
+!
+!--       Horizontally aligned default, natural and urban surfaces
+          CALL calc_albedo( surf_def_h(0) )
+          CALL calc_albedo( surf_lsm_h    )
+          CALL calc_albedo( surf_usm_h    )
+!
+!--       Vertically aligned default, natural and urban surfaces
+          DO  l = 0, 3
+             CALL calc_albedo( surf_def_v(l) )
+             CALL calc_albedo( surf_lsm_v(l) )
+             CALL calc_albedo( surf_usm_v(l) )
+          ENDDO
        ENDIF
 
